Skip to main content
`Ctrl`+`K`
scipy.stats.

# trim_mean

scipy.stats.trim_mean(a, proportiontocut, axis=0)

  Return mean of array after trimming a specified fraction of extreme values

  Removes the specified proportion of elements from each end of the sorted array, then computes the mean of the remaining elements.

  Parameters:
    a array_like

      Input array.

    proportiontocut float

      Fraction of the most positive and most negative elements to remove. When the specified proportion does not result in an integer number of elements, the number of elements to trim is rounded down.

    axis int or None, default: 0

      Axis along which the trimmed means are computed. If None, compute over the raveled array.

  Returns:
    trim_mean ndarray

      Mean of trimmed array.

  See also

  `trimboth`

    Remove a proportion of elements from each end of an array.

  `tmean`

    Compute the mean after trimming values outside specified limits.

  Notes

  For 1-D array a, `trim_mean` is approximately equivalent to the following calculation:

      import numpy as np
      a = np.sort(a)
      m = int(proportiontocut * len(a))
      np.mean(a[m: len(a) - m])

  Examples

      >>> import numpy as np
      >>> from scipy import stats
      >>> x = [1, 2, 3, 5]
      >>> stats.trim_mean(x, 0.25)
      2.5

  When the specified proportion does not result in an integer number of elements, the number of elements to trim is rounded down.

      >>> stats.trim_mean(x, 0.24999) == np.mean(x)
      True

  Use axis to specify the axis along which the calculation is performed.

      >>> x2 = [[1, 2, 3, 5],
      ...       [10, 20, 30, 50]]
      >>> stats.trim_mean(x2, 0.25)
      array([ 5.5, 11. , 16.5, 27.5])
      >>> stats.trim_mean(x2, 0.25, axis=1)
      array([ 2.5, 25. ])